% Calcula la longitud de la curva encerrada bajo los splines interpoladores
% de unos puntos dados, entre el intervalo [A,B]

% Para ello mezclaremos los metodos de Gauss - Legendre y Derivacion
% Numerica

function L = longCurva(pp, A ,B)

 syms('DXP','N','H','XI0','XI','WI','NN','I','X','JX','s','x','K1','K2');

 N = 5;
 
 % Inicializamos los coeficientes de los polinomios de Legendre hasta
 % grado5
 XI = zeros(4,5);
 WI = zeros(4,5);
    XI(1,1) = 0.5773502692;
    XI(1,2) = -XI(1,1);
    WI(1,1) = 1.0;
    WI(1,2) = 1.0;
    XI(2,1) = 0.7745966692;
    XI(2,2) = 0.0;
    XI(2,3) = -XI(2,1); 
    WI(2,1) = 0.5555555556;
    WI(2,2) = 0.8888888889;
    WI(2,3) = WI(2,1);
    XI(3,1) = 0.8611363116;
    XI(3,2) = 0.3399810436;
    XI(3,3) = -XI(3,2);
    XI(3,4) = -XI(3,1);
    WI(3,1) = 0.3478548451;
    WI(3,2) = 0.6521451549;
    WI(3,3) = WI(3,2);
    WI(3,4) = WI(3,1);
    XI(4,1) = 0.9061798459;
    XI(4,2) = 0.5384693101;
    XI(4,3) = 0.0;
    XI(4,4) = -XI(4,2);
    XI(4,5) = -XI(4,1);
    WI(4,1) = 0.2369268850;
    WI(4,2) = 0.4786286705;
    WI(4,3) = 0.5688888889;
    WI(4,4) = WI(4,2);
    WI(4,5) = WI(4,1);
    
 % STEP 1 
 K1 = (B-A)/2;
 K2 = (B+A)/2;
 JX=0;
 
 % Variacion para el calculo de la derivada
 h = 0.01;
 
 for I = 1:N
    % STEP 3 
    X = K1*XI(N-1,I)+K2;
     
    % STEP 4 Calculamos la derivada primera usando derivacion numerica
    DXP= (ppval(pp,X+h) - ppval(pp,X)) / (h);
     
    % STEP 5
    Q = sqrt(1 + DXP^2);
    JX = JX + WI(N-1,I)*Q;
 
 end
 JX=JX*K1;
%La integral de F desde A hasta B es JX;
 L= JX;


